<?php
# Copyright 2006, 2008 Ohio Supercomputer Center
# Revision info:
# $HeadURL: http://svn.osc.edu/repos/pbstools/releases/pbstools-3.1/web/dbutils.php $
# $Revision: 301 $
# $Date: 2009-02-12 10:57:22 -0500 (Thu, 12 Feb 2009) $

# Database abstraction module to reduce the duplication of DB access code
# in the various other reports.
require_once 'DB.php';

function db_connect()
{
  $cfg=array();
  $cfgfile = "db.cfg";
  if ( is_readable($cfgfile) )
    {
      $fp = fopen($cfgfile,"r");
      while ( $line = fgets($fp) )
	{
	  if ( !preg_match('/^#/',$line) )
	    {
	      $token = preg_split('/ *= */',$line);
	      if ( count($token)==2 )
		{
		  $cfg[rtrim($token[0])] = rtrim($token[1]);
		}
	    }
	}
      fclose($fp);
    }
  $db_type="mysql";
  if ( isset($cfg['dbtype']) )
    {
      $db_type=$cfg['dbtype'];
    }
  $db_host="localhost";
  if ( isset($cfg['dbhost']) )
    {
      $db_host=$cfg['dbhost'];
    }
  $db_database="pbsacct";
  if ( isset($cfg['database']) )
    {
      $db_database=$cfg['database'];
    }
  $db_user="webapp";
  if ( isset($cfg['database']) )
    {
      $db_user=$cfg['dbuser'];
    }
  if ( $db_type!="" && $db_host!="" && $db_database!="" && $db_user!="" )
    {
      $db = DB::connect($db_type."://".$db_user."@".$db_host."/".$db_database, FALSE);
      if ( DB::isError($db) )
	{
	  die($db->getMessage());
	}
      else
	{
	  return $db;
	}
    }
  else
    {
      die("Incomplete configuration!");
    }
}

function db_query($db,$query)
{
  $result = $db->query($query);
  if ( DB::isError($db) )
    {
      die ($db->getMessage());
    }
  else
    {
      return $result;
    }
}


function db_disconnect($db)
{
  $db->disconnect();
}

?>